LeetCode 2475. Number of Unequal Triplets in Array【数组,排序,哈希表】简单

这篇具有很好参考价值的文章主要介绍了LeetCode 2475. Number of Unequal Triplets in Array【数组,排序,哈希表】简单。希望对大家有所帮助。如果存在错误或未考虑完全的地方,请大家不吝赐教,您也可以点击"举报违法"按钮提交疑问。

本文属于「征服LeetCode」系列文章之一,这一系列正式开始于2021/08/12。由于LeetCode上部分题目有锁,本系列将至少持续到刷完所有无锁题之日为止;由于LeetCode还在不断地创建新题,本系列的终止日期可能是永远。在这一系列刷题文章中,我不仅会讲解多种解题思路及其优化,还会用多种编程语言实现题解,涉及到通用解法时更将归纳总结出相应的算法模板。

为了方便在PC上运行调试、分享代码文件,我还建立了相关的仓库:https://github.com/memcpy0/LeetCode-Conquest。在这一仓库中,你不仅可以看到LeetCode原题链接、题解代码、题解文章链接、同类题目归纳、通用解法总结等,还可以看到原题出现频率和相关企业等重要信息。如果有其他优选题解,还可以一同分享给他人。

由于本系列文章的内容随时可能发生更新变动,欢迎关注和收藏征服LeetCode系列文章目录一文以作备忘。

给你一个下标从 0 开始的正整数数组 nums 。请你找出并统计满足下述条件的三元组 (i, j, k) 的数目:

  • 0 <= i < j < k < nums.length
  • nums[i]nums[j] 和 nums[k] 两两不同 。
    • 换句话说:nums[i] != nums[j]nums[i] != nums[k] 且 nums[j] != nums[k] 。

返回满足上述条件三元组的数目。

示例 1:

输入:nums = [4,4,2,4,3]
输出:3
解释:下面列出的三元组均满足题目条件:
- (0, 2, 4) 因为 4 != 2 != 3
- (1, 2, 4) 因为 4 != 2 != 3
- (2, 3, 4) 因为 2 != 4 != 3
共计 3 个三元组,返回 3 。
注意 (2, 0, 4) 不是有效的三元组,因为 2 > 0

示例 2:

输入:nums = [1,1,1,1,1]
输出:0
解释:不存在满足条件的三元组,所以返回 0

提示:

  • 3 <= nums.length <= 100
  • 1 <= nums[i] <= 1000

解法1 暴力循环

暴力三重循环:

class Solution {
    public int unequalTriplets(int[] nums) {
        int ans = 0;
        for (int i = 0; i < nums.length; ++i)
            for (int j = i + 1; j < nums.length; ++j)
                for (int k = j + 1; k < nums.length; ++k)
                    if (nums[i] != nums[j] && nums[j] != nums[k] && nums[i] != nums[k]) ++ans;
        return ans;
    }
}

复杂度分析:

  • 时间复杂度: O ( n 3 ) O(n^3) O(n3)
  • 空间复杂度: O ( 1 ) O(1) O(1)

解法2 排序+分组统计

对于 x x x ,设:

  • 小于 x x x 的数有 a a a 个;
  • 等于 x x x 的数有 b b b 个;
  • 大于 x x x 的数有 c c c 个。

那么 x x x 对答案的贡献是 a × b × c a\times b \times c a×b×c 。累加所有贡献,得到答案。

代码实现时,可通过排序快速求出 a   b   c a\ b\ c a b c 。然后从头开始遍历,并分段计算「相同数的个数」。

class Solution {
    public int unequalTriplets(int[] nums) {
        Arrays.sort(nums);
        int ans = 0, start = 0;
        for (int i = 0; i + 1 < nums.length; ++i) {
            if (nums[i] != nums[i + 1]) { // 到一段的末尾
                ans += start * (i - start + 1) * (nums.length - 1 - i);
                start = i + 1;
            }
        } 
        return ans;
    }
}

复杂度分析:

  • 时间复杂度: O ( n log ⁡ n ) O(n\log n) O(nlogn) ,其中 n n n nums \textit{nums} nums 的长度。
  • 空间复杂度: O ( 1 ) O(1) O(1) ,忽略排序时的栈开销,仅用到若干变量。

解法3 计数统计

由于元素的位置是不重要的,我们可以直接用哈希表/数组统计,之前的 a   b   c a\ b\ c a b c 重定义为,按顺序从小到大遍历

  • x x x 之前遍历过的数有 a a a 个;
  • (当前遍历的)等于 x x x 的数有 b b b 个;
  • x x x 之后遍历过的数有 c c c 个。
class Solution {
    public int unequalTriplets(int[] nums) {
        int[] count = new int[1001];
        for (int i : nums) ++count[i];
        int a = 0, b = 0, c = nums.length;
        int ans = 0;
        for (int i = 1; i <= 1000; ++i) {
            if (count[i] != 0) {
                c -= count[i];
                ans += a * count[i] * c;
                a += count[i];
            }
        }
        return ans;
    }
}

复杂度分析:文章来源地址https://www.toymoban.com/news/detail-487067.html

  • 时间复杂度: O ( n ) O(n) O(n) ,其中 n n n nums \textit{nums} nums 的长度。
  • 空间复杂度: O ( 1000 ) O(1000) O(1000)

到了这里,关于LeetCode 2475. Number of Unequal Triplets in Array【数组,排序,哈希表】简单的文章就介绍完了。如果您还想了解更多内容,请在右上角搜索TOY模板网以前的文章或继续浏览下面的相关文章,希望大家以后多多支持TOY模板网!

本文来自互联网用户投稿,该文观点仅代表作者本人,不代表本站立场。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如若转载,请注明出处: 如若内容造成侵权/违法违规/事实不符,请点击违法举报进行投诉反馈,一经查实,立即删除!

领支付宝红包 赞助服务器费用

相关文章

  • LeetCode --- 1929. Concatenation of Array 解题报告

    Given an integer array  nums  of length  n , you want to create an array  ans  of length  2n  where  ans[i] == nums[i]  and  ans[i + n] == nums[i]  for  0 = i n  ( 0-indexed ). Specifically,  ans  is the  concatenation  of two  nums  arrays. Return  the array  ans . Example 1: Example 2:

    2024年02月09日
    浏览(53)
  • LeetCode //C - 933. Number of Recent Calls

    You have a RecentCounter class which counts the number of recent requests within a certain time frame. Implement the RecentCounter class: RecentCounter() Initializes the counter with zero recent requests. int ping(int t) Adds a new request at time t, where t represents some time in milliseconds, and returns the number of requests that has happened in the pas

    2024年01月23日
    浏览(48)
  • 启动nginx报错:invalid number of arguments in “root“ directive in,是文件路径书写问题

    无法启动nginx,错误日志提示如下: 原因: 这个一个比较常见的问题,配置文件里面应该有路径有问题 注意在:这里如果路径名称有空格要用引号引起来,否则会被当成2个路径解析。 如上,提示nginx.conf文件的208行, 改成这样就没事了:

    2024年02月09日
    浏览(50)
  • Java异常 #Number of lines annotated by Git is not equal to number of lines in the file, check file …

    在项目中某个 java 文件左边栏右键查看代码版本履历(Annotate)时无法显示,IDEA 提示:Number of lines annotated by Git is not equal to number of lines in the file, check file encoding and line separators.   这个问题涉及到不同操作系统下文本文件的换行符差异引起的。在不同操作系统中,文本文件的

    2024年02月03日
    浏览(42)
  • LeetCode452. Minimum Number of Arrows to Burst Balloons

    There are some spherical balloons taped onto a flat wall that represents the XY-plane. The balloons are represented as a 2D integer array points where points[i] = [xstart, xend] denotes a balloon whose horizontal diameter stretches between xstart and xend. You do not know the exact y-coordinates of the balloons. Arrows can be shot up directly vertically (in

    2024年02月04日
    浏览(41)
  • LeetCode 1921. Eliminate Maximum Number of Monsters【贪心,计数排序】1527

    本文属于「征服LeetCode」系列文章之一,这一系列正式开始于2021/08/12。由于LeetCode上部分题目有锁,本系列将至少持续到刷完所有无锁题之日为止;由于LeetCode还在不断地创建新题,本系列的终止日期可能是永远。在这一系列刷题文章中,我不仅会讲解多种解题思路及其优化,

    2024年02月09日
    浏览(49)
  • Bitstream:stanbsbitfile.c:3408:1.57 - Incorrect number of bits in bitstream

    使用Spartan 6的FPGA,经常报这个错误。     Map属性设置,other map command line options 里面写上语句 \\\"-convert_bram8\\\",强制按8bit进行block ram初始化,然后就好了。可以试一下 

    2024年02月16日
    浏览(38)
  • LeetCode --- 1903. Largest Odd Number in String 解题报告

    You are given a string  num , representing a large integer. Return  the  largest-valued odd  integer (as a string) that is a  non-empty substring  of  num , or an empty string  \\\"\\\"  if no odd integer exists . A  substring  is a contiguous sequence of characters within a string. Example 1: Example 2: Example 3:

    2024年02月10日
    浏览(34)
  • Leetcode 3016. Minimum Number of Pushes to Type Word II

    Leetcode 3016. Minimum Number of Pushes to Type Word II 1. 解题思路 2. 代码实现 题目链接:3016. Minimum Number of Pushes to Type Word II 这道题的话思路其实还是蛮简单的,显然我们的目的是要令对给定的word在键盘上敲击的次数最小。 因此,我们只需要对单词当中按照字符的频次进行倒序排列,

    2024年01月22日
    浏览(46)
  • LeetCode //C - 452. Minimum Number of Arrows to Burst Balloons

    There are some spherical balloons taped onto a flat wall that represents the XY-plane. The balloons are represented as a 2D integer array points where points[i] = [ x s t a r t , x e n d x_{start}, x_{end} x s t a r t ​ , x e n d ​ ] denotes a balloon whose horizontal diameter stretches between x s t a r t x_{start} x s t a r t ​ and x e n d x_{end} x

    2024年02月12日
    浏览(43)

觉得文章有用就打赏一下文章作者

支付宝扫一扫打赏

博客赞助

微信扫一扫打赏

请作者喝杯咖啡吧~博客赞助

支付宝扫一扫领取红包,优惠每天领

二维码1

领取红包

二维码2

领红包